KNIFE-DIFF(1)

NAME
knife-diff - The man page for the knife diff subcommand.

The knife diff subcommand is used to compare the differences between files and directories on the Chef server and in the chef-repo. For example, to compare files on the Chef server prior to an uploading or downloading files using the knife download and knife upload subcommands, or to ensure that certain files in multiple production environments are the same. This subcommand is similar to the git diff command that can be used to diff what is in the chef-repo with what is synced to a git repository.

Syntax

This subcommand has the following syntax:

$ knife diff [PATTERN...] (options)

Options

This subcommand has the following options:

-c CONFIG_FILE, --config CONFIG_FILE
    The configuration file to use.

--chef-repo-path PATH
    The path to the chef-repo. This setting will override the default path to the chef-repo. Default: same as specified by chef_repo_path in config.rb.

--chef-zero-port PORT
    The port on which chef-zero will listen.

--[no-]color
    Use to view colored output.

--cookbook-version VERSION
    The version of a cookbook to be downloaded.

--concurrency
    The number of allowed concurrent connections. Default: 10.

-d, --disable-editing
    Use to prevent the $EDITOR from being opened and to accept data as-is.

--defaults
    Use to have knife use the default value instead of asking a user to provide one.

--diff-filter=[(A|D|M|T)...[*]]
    Use to select only files that have been added (A), deleted (D), modified (M), and/or have had their type changed (T). Any combination of filter characters may be used, including no filter characters. Use * to select all paths if a file matches other criteria in the comparison. Default value: nil.

-e EDITOR, --editor EDITOR
    The $EDITOR that is used for all interactive commands.

-E ENVIRONMENT, --environment ENVIRONMENT
    The name of the environment. When this option is added to a command, the command will run only against the named environment.

-F FORMAT, --format FORMAT
    The output format: summary (default), text, json, yaml, and pp.

-h, --help
    Shows help for the command.

-k KEY, --key KEY
    The private key that knife will use to sign requests made by the API client to the Chef server.

--name-only
    Use to show only the names of modified files.

--name-status
    Use to show only the names of files with a status of Added, Deleted, Modified, or Type Changed.

--no-recurse
    Use --no-recurse to disable listing a directory recursively. Default: --recurse.

--print-after
    Use to show data after a destructive operation.

--repo-mode MODE
    The layout of the local chef-repo. Possible values: static, everything, or hosted_everything. Use static for just roles, environments, cookbooks, and data bags. By default, everything and hosted_everything are dynamically selected depending on the server type. Default: everything / hosted_everything.

-s URL, --server-url URL
    The URL for the Chef server.

-u USER, --user USER
    The user name used by knife to sign requests made by the API client to the Chef server. Authentication will fail if the user name does not match the private key.

-v, --version
    The version of the chef-client.

-V, --verbose
    Set for more verbose outputs. Use -VV for maximum verbosity.

-y, --yes
    Use to respond to all confirmation prompts with "Yes". knife will not ask for confirmation.

-z, --local-mode
    Use to run the chef-client in local mode. This allows all commands that work against the Chef server to also work against the local chef-repo.

    knife.rb File Settings

    In addition to the default settings in a knife.rb file, there are other subcommand-specific settings that can be added. When a subcommand is run, knife will use:

1.  A value passed via the command-line

2.  A value contained in the knife.rb file

3.  The default value

    A value passed via the command line will override a value in the knife.rb file; a value in a knife.rb file will override a default value.

    The following knife diff settings can be added to the knife.rb file:

knife[:chef_repo_path]
    Use to add the --chef-repo-path option.

knife[:concurrency]
    Use to add the --concurrency option.

knife[:name_only]
    Use to add the --name-only option.

knife[:name_status]
    Use to add the --name-status option.

knife[:recurse]
    Use to add the --recurse option.

knife[:repo_mode]
    Use to add the --repo-mode option.

    Examples

    To compare the base.json role to a webserver.json role, enter:

    $ knife diff roles/base.json roles/webserver.json

    To compare the differences between the local chef-repo and the files that are on the Chef server, enter:

    $ knife diff

    To diff a node named node-lb and then only return files that have been added, deleted, modified, or changed, enter:

    $ knife diff --name-status node-lb

    to return something like:

    node-lb/recipes/eip.rb
    node-lb/recipes/heartbeat-int.rb
    node-lb/templates/default/corpsite.conf.erb
    node-lb/files/default/wildcard.node.com.crt
    node-lb/files/default/wildcard.node.com.crt-2009
    node-lb/files/default/wildcard.node.com.key
    node-lb/.gitignore
    node-lb/Rakefile

AUTHOR
Chef